#!/bin/perl

use strict;



my @dictionary;
my %used;
my @ordem;
my @keyword;


my $prod =1;

my $maior =0;

my $espaco = "";

my $x;
my $y;

my $tamanho ="15";
my $tamanho_interno="13";

my $margem = int(($tamanho - $tamanho_interno)/2);

my $quadrado = "\\framebox($tamanho,$tamanho){ }";

#my $put = "\\put($x,$y){$quadrado}";
my $prefixo = "\\documentstyle{article}\n\\begin{document}\n\\begin{picture}(200,200)\n";
my $sufixo = "\\end{picture}\n\\end{document}";

my $dquadrado = "";

open (DIC,"palavras.txt") or die;

while(<DIC>) {
  chomp($_);
  push(@dictionary,$_);
  printf "$_ "  unless $prod; 
}
printf "\n" unless $prod;

@keyword = qw(a b c d e); #split("abcd",".");

#$keyword = uc $keyword;

my $i;

for ($i=0;$i<$#keyword; $i++) {
  my $letra = $keyword[$i];
  my $index = int(rand($#dictionary));

  while (! ($dictionary[$index] =~ /$letra/) ) {
    $index++;
    if ($index > $#dictionary) {
      $index =0;
    }
  }
  my $posicao = index ($dictionary[$index],$letra);
  $maior = $posicao if ($posicao>$maior);
  $used{$dictionary[$index]}=$posicao;
  push(@ordem,$dictionary[$index]);
  printf "$letra $index $dictionary[$index]\n" unless $prod;
  @dictionary = (@dictionary[0..$index-1] , @dictionary[$index+1..$#dictionary]);
}

my $x,$y;
for ($i=0;$i<$#keyword; $i++) {
  for (my $j=0;$j<($maior - $used{$ordem[$i]});$j++) {
    print "*" unless $prod;
  }
  printf "$ordem[$i]\n" unless $prod;
}

printf "$prefixo";
for ($i=0;$i<$#keyword; $i++) {
  $y=200 - $i*$tamanho + $margem;
  $x = 90 + $margem;
  printf "\\put($x,$y){\\framebox($tamanho_interno,$tamanho_interno){}}\n";
  $y-=$margem;
  $x = 90 - ($used{$ordem[$i]})*$tamanho;
  for (my $j=0;$j < (length $ordem[$i]); $j++) {
    printf "\\put($x,$y){$quadrado} ";
    $x+=15;
  }
  printf "\n% %     $ordem[$i]\n";
}


printf "$sufixo \n";

